/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Virt.xs. Do not edit this file, edit Virt.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Virt.xs"
/* -*- c -*-
 *
 * Copyright (C) 2006 Red Hat
 * Copyright (C) 2006-2007 Daniel P. Berrange
 *
 * This program is free software; You can redistribute it and/or modify
 * it under either:
 *
 * a) the GNU General Public License as published by the Free
 *   Software Foundation; either version 2, or (at your option) any
 *   later version,
 *
 * or
 *
 * b) the "Artistic License"
 *
 * The file "LICENSE" distributed along with this file provides full
 * details of the terms and conditions of the two licenses.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <libvirt/virterror.h>
#include <libvirt/libvirt.h>

/*
 * On 32-bit OS (and some 64-bit) Perl does not have an
 * integer type capable of storing 64 bit numbers. So
 * we serialize to/from strings on these platforms
 */

long long
virt_SvIVll(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    return strtoll(SvPV_nolen(sv), NULL, 10);
#endif
}

unsigned long long
virt_SvIVull(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    return strtoull(SvPV_nolen(sv), NULL, 10);
#endif
}


#ifndef PRId64
#define PRId64 "lld"
#endif

SV *
virt_newSVll(long long val) {
#ifdef USE_64_BIT_ALL
    return newSViv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRId64, val);
    return newSVpv(buf, len);
#endif
}

#ifndef PRIu64
#define PRIu64 "llu"
#endif

SV *
virt_newSVull(unsigned long long val) {
#ifdef USE_64_BIT_ALL
    return newSVuv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRIu64, val);
    return newSVpv(buf, len);
#endif
}



void	ignoreVirErrorFunc(void * userData, virErrorPtr error) {
  /* Do nothing */
}

SV *
_sv_from_error (virErrorPtr error)
{
    HV *hv;

    hv = newHV ();

    /* Map virErrorPtr attributes to hash keys */
    (void)hv_store (hv, "code", 4, newSViv (error ? error->code : 0), 0);
    (void)hv_store (hv, "domain", 6, newSViv (error ? error->domain : VIR_FROM_NONE), 0);
    (void)hv_store (hv, "message", 7, newSVpv (error ? error->message : "Unknown problem", 0), 0);

    return sv_bless (newRV_noinc ((SV*) hv), gv_stashpv ("Sys::Virt::Error", TRUE));
}


void
_croak_error (virErrorPtr error)
{
    sv_setsv (ERRSV, _sv_from_error (error));

    /* croak does not return, so we free this now to avoid leaking */
    virResetError (error);

    croak (Nullch);
}

void
_populate_constant(HV *stash, char *name, int val)
{
    SV *valsv;

    valsv = newSViv(0);
    sv_setuv(valsv,val);
    newCONSTSUB(stash, name, valsv);
}

#define REGISTER_CONSTANT(name, key) _populate_constant(stash, #key, name)

static int
_domain_event_callback(virConnectPtr con,
		       virDomainPtr dom,
		       int event,
		       int detail,
		       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(event)));
    XPUSHs(sv_2mortal(newSViv(detail)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}

static void
_domain_event_free(void *opaque)
{
  SV *sv = opaque;
  SvREFCNT_dec(sv);
}

static int
_event_add_handle(int fd,
		  int events,
		  virEventHandleCallback cb,
		  void *opaque,
		  virFreeCallback ff)
{
    SV *cbref;
    SV *opaqueref;
    SV *ffref;
    int ret;
    int watch = 0;
    dSP;

    ENTER;
    SAVETMPS;

    cbref= sv_newmortal();
    opaqueref= sv_newmortal();
    ffref= sv_newmortal();

    sv_setref_pv(cbref, NULL, cb);
    sv_setref_pv(opaqueref, NULL, opaque);
    sv_setref_pv(ffref, NULL, ff);

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(fd)));
    XPUSHs(sv_2mortal(newSViv(events)));
    XPUSHs(cbref);
    XPUSHs(opaqueref);
    XPUSHs(ffref);
    PUTBACK;

    ret = call_pv("Sys::Virt::Event::_add_handle", G_SCALAR);

    SPAGAIN;

    if (ret == 1)
      watch = POPi;

    FREETMPS;
    LEAVE;

    if (ret != 1)
      return -1;

    return watch;
}

static void
_event_update_handle(int watch,
		     int events)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    XPUSHs(sv_2mortal(newSViv(events)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_update_handle", G_DISCARD);

    FREETMPS;
    LEAVE;
}

static int
_event_remove_handle(int watch)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_remove_handle", G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
    return 0;
}

static int
_event_add_timeout(int interval,
		   virEventTimeoutCallback cb,
		   void *opaque,
		   virFreeCallback ff)
{
    SV *cbref;
    SV *opaqueref;
    SV *ffref;
    int ret;
    int timer = 0;
    dSP;

    ENTER;
    SAVETMPS;

    cbref = sv_newmortal();
    opaqueref = sv_newmortal();
    ffref = sv_newmortal();

    sv_setref_pv(cbref, NULL, cb);
    sv_setref_pv(opaqueref, NULL, opaque);
    sv_setref_pv(ffref, NULL, ff);

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(interval)));
    XPUSHs(cbref);
    XPUSHs(opaqueref);
    XPUSHs(ffref);
    PUTBACK;

    ret = call_pv("Sys::Virt::Event::_add_timeout", G_SCALAR);

    SPAGAIN;

    if (ret == 1)
      timer = POPi;

    FREETMPS;
    LEAVE;

    if (ret != 1)
      return -1;

    return timer;
}

static void
_event_update_timeout(int timer,
		      int interval)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    XPUSHs(sv_2mortal(newSViv(interval)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_update_timeout", G_DISCARD);

    FREETMPS;
    LEAVE;
}

static int
_event_remove_timeout(int timer)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_remove_timeout", G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_open_auth_callback(virConnectCredentialPtr cred,
		    unsigned int ncred,
		    void *cbdata)
{
  dSP;
  int i, ret, success = -1;
  AV *credlist;

  credlist = newAV();

  ENTER;
  SAVETMPS;
  PUSHMARK(SP);

  for (i = 0 ; i < ncred ; i++) {
      HV *credrec = newHV();

      (void)hv_store(credrec, "type", 4, newSViv(cred[i].type), 0);
      (void)hv_store(credrec, "prompt", 6, newSVpv(cred[i].prompt, 0), 0);
      (void)hv_store(credrec, "challenge", 9, newSVpv(cred[i].challenge, 0), 0);
      (void)hv_store(credrec, "result", 6, newSVpv(cred[i].defresult, 0), 0);

      av_push(credlist, newRV_noinc((SV *)credrec));
  }
  SvREFCNT_inc((SV*)credlist);

  XPUSHs(newRV_noinc((SV*)credlist));
  PUTBACK;

  ret = call_sv((SV*)cbdata, G_SCALAR);

  SPAGAIN;

  if (ret == 1)
     success = POPi;

  for (i = 0 ; i < ncred ; i++) {
      SV **credsv = av_fetch(credlist, i, 0);
      HV *credrec = (HV*)SvRV(*credsv);
      SV **val = hv_fetch(credrec, "result", 6, 0);

      if (val && SvOK(*val)) {
	  STRLEN len;
	  char *result = SvPV(*val, len);
	  if (!(cred[i].result = malloc(len+1)))
	      abort();
	  memcpy(cred[i].result, result, len+1);
	  cred[i].resultlen = (unsigned int)len;
      } else {
	  cred[i].resultlen = 0;
	  cred[i].result = NULL;
      }
  }

  FREETMPS;
  LEAVE;

  return success;
}


#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 430 "Virt.c"

XS(XS_Sys__Virt__open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::_open", "name, readonly");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	name = (char *)SvPV_nolen(ST(0));
	int	readonly = (int)SvIV(ST(1));
	virConnectPtr	RETVAL;
#line 425 "Virt.xs"
      if (!strcmp(name, "")) {
	name = NULL;
      }
      if (readonly) {
	RETVAL = virConnectOpenReadOnly(name);
      } else {
	RETVAL = virConnectOpen(name);
      }
      if (!RETVAL) {
	_croak_error(virGetLastError());
      }
#line 459 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__open_auth); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__open_auth)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::_open_auth", "name, readonly, creds, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	name = (const char *)SvPV_nolen(ST(0));
	int	readonly = (int)SvIV(ST(1));
	SV *	creds = ST(2);
	SV *	cb = ST(3);
#line 447 "Virt.xs"
      AV *credlist;
      virConnectAuth auth;
      int i;
#line 490 "Virt.c"
	virConnectPtr	RETVAL;
#line 451 "Virt.xs"
      if (SvOK(cb) && SvOK(creds)) {
	  memset(&auth, 0, sizeof auth);
	  credlist = (AV*)SvRV(creds);
	  auth.ncredtype = av_len(credlist) + 1;
	  Newx(auth.credtype, auth.ncredtype, int);
	  for (i = 0 ; i < auth.ncredtype ; i++) {
	    SV **type = av_fetch(credlist, i, 0);
	    auth.credtype[i] = SvIV(*type);
	  }

	  auth.cb = _open_auth_callback;
	  auth.cbdata = cb;
	  RETVAL = virConnectOpenAuth(name,
				      &auth,
				      readonly ? VIR_CONNECT_RO : 0);
      } else {
	  RETVAL = virConnectOpenAuth(name,
				      virConnectAuthPtrDefault,
				      readonly ? VIR_CONNECT_RO : 0);
      }
      if (!RETVAL) {
	_croak_error(virGetLastError());
      }
#line 516 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_restore_domain); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_restore_domain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::restore_domain", "con, from");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	const char *	from = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::restore_domain() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 482 "Virt.xs"
      if((virDomainRestore(con, from)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 554 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__get_library_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__get_library_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::_get_library_version", "void");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 489 "Virt.xs"
      unsigned long version;
#line 575 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;
#line 491 "Virt.xs"
      if (virGetVersion(&version, NULL, NULL) < 0) {
	_croak_error(virGetLastError());
      }
      RETVAL = version;
#line 583 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__get_conn_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__get_conn_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::_get_conn_version", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
#line 502 "Virt.xs"
      unsigned long version;
#line 605 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::_get_conn_version() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 504 "Virt.xs"
      if (virConnectGetVersion(con, &version) < 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = version;
#line 620 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_type", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_type() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 515 "Virt.xs"
      RETVAL = virConnectGetType(con);
#line 651 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_uri); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_uri)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_uri", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_uri() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 523 "Virt.xs"
      RETVAL = virConnectGetURI(con);
#line 682 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_node_info", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
#line 531 "Virt.xs"
      virNodeInfo info;
#line 704 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_info() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 533 "Virt.xs"
      if (virNodeGetInfo(con, &info) < 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "model", 5, newSVpv(info.model, 0), 0);
      (void)hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
      (void)hv_store (RETVAL, "cpus", 4, newSViv(info.cpus), 0);
      (void)hv_store (RETVAL, "mhz", 3, newSViv(info.mhz), 0);
      (void)hv_store (RETVAL, "nodes", 5, newSViv(info.nodes), 0);
      (void)hv_store (RETVAL, "sockets", 7, newSViv(info.sockets), 0);
      (void)hv_store (RETVAL, "cores", 5, newSViv(info.cores), 0);
      (void)hv_store (RETVAL, "threads", 7, newSViv(info.threads), 0);
#line 726 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_security_model); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_security_model)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_node_security_model", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
#line 553 "Virt.xs"
      virSecurityModel secmodel;
#line 749 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_security_model() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 555 "Virt.xs"
      if (virNodeGetSecurityModel(con, &secmodel) < 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "model", 5, newSVpv(secmodel.model, 0), 0);
      (void)hv_store (RETVAL, "doi", 3, newSVpv(secmodel.doi, 0), 0);
#line 765 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_free_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_free_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_node_free_memory", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
#line 568 "Virt.xs"
      unsigned long long mem;
#line 788 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_free_memory() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 570 "Virt.xs"
      if ((mem = virNodeGetFreeMemory(con)) == 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = virt_newSVull(mem);
#line 802 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_cells_free_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_cells_free_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_node_cells_free_memory", "con, start, end");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	start = (int)SvIV(ST(1));
	int	end = (int)SvIV(ST(2));
#line 584 "Virt.xs"
      unsigned long long *mem;
      int i, num;
#line 830 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_cells_free_memory() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 587 "Virt.xs"
      Newx(mem, end-start, unsigned long long);
      if ((num = virNodeGetCellsFreeMemory(con, mem, start, end)) < 0) {
	Safefree(mem);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, num);
      for (i = 0 ; i < num ; i++) {
	SV *val = newSViv(mem[i]);
	PUSHs(sv_2mortal(val));
      }
      Safefree(mem);
#line 850 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_find_storage_pool_sources); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_find_storage_pool_sources)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::find_storage_pool_sources", "con, type, srcspec, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	type = (const char *)SvPV_nolen(ST(1));
	const char *	srcspec = (const char *)SvPV_nolen(ST(2));
	unsigned int	flags = (unsigned int)SvUV(ST(3));
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::find_storage_pool_sources() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 607 "Virt.xs"
      if ((RETVAL = virConnectFindStoragePoolSources(con, type, srcspec, flags)) == NULL) {
	_croak_error(virConnGetLastError(con));
      }
#line 886 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_capabilities); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_capabilities)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_capabilities", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
#line 618 "Virt.xs"
      char *xml;
#line 908 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_capabilities() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 620 "Virt.xs"
      if (!(xml = virConnectGetCapabilities(con))) {
	 _croak_error(virConnGetLastError(con));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 923 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_max_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_max_vcpus", "con, type");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	char *	type = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_max_vcpus() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 633 "Virt.xs"
      if ((RETVAL = virConnectGetMaxVcpus(con, type)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 958 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_hostname); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_hostname)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_hostname", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
#line 643 "Virt.xs"
      char *host;
#line 980 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_hostname() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 645 "Virt.xs"
      if ((host = virConnectGetHostname(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = newSVpv(host, 0);
      free(host);
#line 995 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_num_of_domains); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_domains)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::num_of_domains", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 657 "Virt.xs"
      if ((RETVAL = virConnectNumOfDomains(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1029 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_domain_ids); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_domain_ids)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::list_domain_ids", "con, maxids");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxids = (int)SvIV(ST(1));
#line 668 "Virt.xs"
      int *ids;
      int i, nid;
#line 1055 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_domain_ids() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 671 "Virt.xs"
      Newx(ids, maxids, int);
      if ((nid = virConnectListDomains(con, ids, maxids)) < 0) {
        Safefree(ids);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nid);
      for (i = 0 ; i < nid ; i++) {
	PUSHs(sv_2mortal(newSViv(ids[i])));
      }
      Safefree(ids);
#line 1074 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_domains); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_domains)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::num_of_defined_domains", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 687 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedDomains(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1107 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_domain_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_domain_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::list_defined_domain_names", "con, maxnames");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 698 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 1134 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_domain_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 702 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedDomains(con, names, maxnames)) < 0) {
	Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
      }
      Safefree(names);
#line 1154 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_networks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_networks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::num_of_networks", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 719 "Virt.xs"
      if ((RETVAL = virConnectNumOfNetworks(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1187 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_network_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_network_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::list_network_names", "con, maxnames");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 730 "Virt.xs"
      char **names;
      int i, nnet;
#line 1213 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 733 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListNetworks(con, names, maxnames)) < 0) {
        Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 1233 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_networks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_networks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::num_of_defined_networks", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 750 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedNetworks(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1266 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_network_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_network_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::list_defined_network_names", "con, maxnames");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 761 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 1293 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 765 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedNetworks(con, names, maxnames)) < 0) {
	Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
      }
      Safefree(names);
#line 1313 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_storage_pools)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::num_of_storage_pools", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 782 "Virt.xs"
      if ((RETVAL = virConnectNumOfStoragePools(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1346 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_storage_pool_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_storage_pool_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::list_storage_pool_names", "con, maxnames");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 793 "Virt.xs"
      char **names;
      int i, nnet;
#line 1372 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_storage_pool_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 796 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListStoragePools(con, names, maxnames)) < 0) {
        Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 1392 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_storage_pools)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::num_of_defined_storage_pools", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 813 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedStoragePools(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1425 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_storage_pool_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_storage_pool_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::list_defined_storage_pool_names", "con, maxnames");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 824 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 1452 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_storage_pool_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 828 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedStoragePools(con, names, maxnames)) < 0) {
	Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
      }
      Safefree(names);
#line 1472 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_node_devices); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_node_devices)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::num_of_node_devices", "con, cap, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	cap = (const char *)SvPV_nolen(ST(1));
	int	flags = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_node_devices() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 847 "Virt.xs"
      if ((RETVAL = virNodeNumOfDevices(con, cap, flags)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1507 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_node_device_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_node_device_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::list_node_device_names", "con, cap, maxnames, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	const char *	cap = (const char *)SvPV_nolen(ST(1));
	int	maxnames = (int)SvIV(ST(2));
	int	flags = (int)SvIV(ST(3));
#line 860 "Virt.xs"
      char **names;
      int i, nnet;
#line 1535 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_node_device_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 863 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virNodeListDevices(con, cap, names, maxnames, flags)) < 0) {
        Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 1555 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_domain_event_register); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_event_register)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::domain_event_register", "conref, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	conref = ST(0);
	SV*	cb = ST(1);
#line 883 "Virt.xs"
      AV *opaque;
      virConnectPtr con;
#line 1581 "Virt.c"
#line 886 "Virt.xs"
      con = (virConnectPtr)SvIV((SV*)SvRV(conref));
      opaque = newAV();
      SvREFCNT_inc(cb);
      SvREFCNT_inc(conref);
      av_push(opaque, conref);
      av_push(opaque, cb);
      virConnectDomainEventRegister(con, _domain_event_callback, opaque, _domain_event_free);
#line 1590 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_domain_event_deregister); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_event_deregister)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::domain_event_deregister", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::domain_event_deregister() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 898 "Virt.xs"
      virConnectDomainEventDeregister(con, _domain_event_callback);
#line 1621 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::DESTROY", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::DESTROY() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 904 "Virt.xs"
      virConnectClose(con);
#line 1652 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain__create_linux); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__create_linux)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_create_linux", "con, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_create_linux() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 913 "Virt.xs"
      /* Don't bother using virDomainCreateXML, since this works
         for more versions */
      if (!(RETVAL = virDomainCreateLinux(con, xml, 0))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1687 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_define_xml", "con, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 926 "Virt.xs"
      if (!(RETVAL = virDomainDefineXML(con, xml))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1722 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_lookup_by_id", "con, id");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	id = (int)SvIV(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_id() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 937 "Virt.xs"
      if (!(RETVAL = virDomainLookupByID(con, id))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1757 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_lookup_by_name", "con, name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 948 "Virt.xs"
      if (!(RETVAL = virDomainLookupByName(con, name))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1792 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_lookup_by_uuid", "con, uuid");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 959 "Virt.xs"
      if (!(RETVAL = virDomainLookupByUUID(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1827 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_lookup_by_uuid_string", "con, uuid");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 970 "Virt.xs"
      if (!(RETVAL = virDomainLookupByUUIDString(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1862 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_id", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_id() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 980 "Virt.xs"
      RETVAL = virDomainGetID(dom);
#line 1895 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_uuid", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 989 "Virt.xs"
      unsigned char rawuuid[16];
#line 1917 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_uuid() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 991 "Virt.xs"
      if ((virDomainGetUUID(dom, rawuuid)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpv((char*)rawuuid, 16);
#line 1931 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_uuid_string", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 1002 "Virt.xs"
      char uuid[36];
#line 1954 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_uuid_string() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1004 "Virt.xs"
      if ((virDomainGetUUIDString(dom, uuid)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }

      RETVAL = newSVpv(uuid, 0);
#line 1969 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_name", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_name() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1016 "Virt.xs"
      if (!(RETVAL = virDomainGetName(dom))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2003 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_suspend); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_suspend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::suspend", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::suspend() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1027 "Virt.xs"
      if ((virDomainSuspend(dom)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2036 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_resume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_resume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::resume", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::resume() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1036 "Virt.xs"
      if ((virDomainResume(dom)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2069 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_save); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_save)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::save", "dom, to");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	to = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::save() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1046 "Virt.xs"
      if ((virDomainSave(dom, to)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2103 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_core_dump); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_core_dump)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::core_dump", "dom, to, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	to = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags = (unsigned int)SvUV(ST(2));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::core_dump() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1056 "Virt.xs"
      if (virDomainCoreDump(dom, to, flags) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2138 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_info", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 1065 "Virt.xs"
      virDomainInfo info;
#line 2160 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1067 "Virt.xs"
      if (virDomainGetInfo(dom, &info) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
      (void)hv_store (RETVAL, "maxMem", 6, newSViv(info.maxMem), 0);
      (void)hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
      (void)hv_store (RETVAL, "nrVirtCpu", 9, newSViv(info.nrVirtCpu), 0);
      (void)hv_store (RETVAL, "cpuTime", 7, virt_newSVull(info.cpuTime), 0);
#line 2179 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_scheduler_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_scheduler_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_scheduler_parameters", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 1084 "Virt.xs"
      virSchedParameter *params;
      int nparams;
      unsigned int i;
      char *type;
#line 2205 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_scheduler_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1089 "Virt.xs"
      if (!(type = virDomainGetSchedulerType(dom, &nparams))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      free(type);
      Newx(params, nparams, virSchedParameter);
      if (virDomainGetSchedulerParameters(dom, params, &nparams) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      for (i = 0 ; i < nparams ; i++) {
	SV *val = NULL;

	switch (params[i].type) {
	case VIR_DOMAIN_SCHED_FIELD_INT:
	  val = newSViv(params[i].value.i);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_UINT:
	  val = newSViv((int)params[i].value.ui);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_LLONG:
	  val = virt_newSVll(params[i].value.l);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_ULLONG:
	  val = virt_newSVull(params[i].value.ul);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_DOUBLE:
	  val = newSVnv(params[i].value.d);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_BOOLEAN:
	  val = newSViv(params[i].value.b);
	  break;
	}

	(void)hv_store (RETVAL, params[i].field, strlen(params[i].field), val, 0);
      }
#line 2255 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_scheduler_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_scheduler_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::set_scheduler_parameters", "dom, newparams");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
#line 1137 "Virt.xs"
      virSchedParameter *params;
      int nparams;
      unsigned int i;
      char *type;
#line 2284 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_scheduler_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVHV)
	    newparams = (HV*)SvRV(ST(1));
	else
	    Perl_croak(aTHX_ "%s: %s is not a hash reference",
			"Sys::Virt::Domain::set_scheduler_parameters",
			"newparams");
#line 1142 "Virt.xs"
      if (!(type = virDomainGetSchedulerType(dom, &nparams))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      free(type);
      Newx(params, nparams, virSchedParameter);
      if (virDomainGetSchedulerParameters(dom, params, &nparams) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      for (i = 0 ; i < nparams ; i++) {
	SV **val;

	if (!hv_exists(newparams, params[i].field, strlen(params[i].field)))
	  continue;

	val = hv_fetch (newparams, params[i].field, strlen(params[i].field), 0);

	switch (params[i].type) {
	case VIR_DOMAIN_SCHED_FIELD_INT:
	  params[i].value.i = SvIV(*val);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_UINT:
	  params[i].value.ui = SvIV(*val);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_LLONG:
	  params[i].value.l = virt_SvIVll(*val);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_ULLONG:
	  params[i].value.ul = virt_SvIVull(*val);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_DOUBLE:
	  params[i].value.d = SvNV(*val);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_BOOLEAN:
	  params[i].value.b = SvIV(*val);
	  break;
	}

      }
      if (virDomainSetSchedulerParameters(dom, params, nparams) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2346 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_max_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_max_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_max_memory", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1194 "Virt.xs"
      if (!(RETVAL = virDomainGetMaxMemory(dom))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2379 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_max_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_max_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::set_max_memory", "dom, val");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1205 "Virt.xs"
      if (virDomainSetMaxMemory(dom, val) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2413 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_set_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::set_memory", "dom, val");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1215 "Virt.xs"
      if (virDomainSetMemory(dom, val) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2447 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_max_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_max_vcpus", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_max_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1223 "Virt.xs"
      if (!(RETVAL = virDomainGetMaxVcpus(dom))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2480 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::set_vcpus", "dom, num");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	num = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1235 "Virt.xs"
      if (virDomainSetVcpus(dom, num) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2514 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::set_autostart", "dom, autostart");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	autostart = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_autostart() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1245 "Virt.xs"
      if (virDomainSetAutostart(dom, autostart) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2548 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_autostart", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 1254 "Virt.xs"
      int autostart;
#line 2570 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_autostart() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1256 "Virt.xs"
      if (virDomainGetAutostart(dom, &autostart) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = autostart;
#line 2585 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_scheduler_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_scheduler_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_scheduler_type", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 1268 "Virt.xs"
      int nparams;
#line 2607 "Virt.c"
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_scheduler_type() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1270 "Virt.xs"
      if ((RETVAL = virDomainGetSchedulerType(dom, &nparams)) == NULL) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2621 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_os_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_os_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_os_type", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 1281 "Virt.xs"
      char *type;
#line 2643 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_os_type() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1283 "Virt.xs"
      if (!(type = virDomainGetOSType(dom))) {
	 _croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpv(type, 0);
      free(type);
#line 2658 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_xml_description", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 1295 "Virt.xs"
      char *xml;
#line 2681 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_xml_description() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1297 "Virt.xs"
      if (!(xml = virDomainGetXMLDesc(dom, 0))) {
	 _croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 2696 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_shutdown); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_shutdown)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::shutdown", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::shutdown() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1309 "Virt.xs"
      if (virDomainShutdown(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2730 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_reboot); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_reboot)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::reboot", "dom, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags = (unsigned int)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::reboot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1318 "Virt.xs"
      if (virDomainReboot(dom, flags) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2764 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::undefine", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::undefine() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1326 "Virt.xs"
      if (virDomainUndefine(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2797 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::create", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::create() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1334 "Virt.xs"
      if (virDomainCreate(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2830 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_migrate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_migrate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::migrate", "dom, destcon, flags, dname, uri, bandwidth");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	virConnectPtr	destcon;
	unsigned long	flags = (unsigned long)SvUV(ST(2));
	const char *	dname = (const char *)SvPV_nolen(ST(3));
	const char *	uri = (const char *)SvPV_nolen(ST(4));
	unsigned long	bandwidth = (unsigned long)SvUV(ST(5));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::migrate() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        destcon = (virConnectPtr)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Sys::Virt::Domain::migrate() -- destcon is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1348 "Virt.xs"
     if ((RETVAL = virDomainMigrate(dom, destcon, flags, dname, uri, bandwidth)) == NULL) {
       _croak_error(virConnGetLastError(virDomainGetConnect(dom)));
     }
#line 2874 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_attach_device); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_attach_device)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::attach_device", "dom, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::attach_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1359 "Virt.xs"
      if (virDomainAttachDevice(dom, xml) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2910 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_detach_device); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_detach_device)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::detach_device", "dom, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::detach_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1369 "Virt.xs"
      if (virDomainDetachDevice(dom, xml) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2944 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_block_stats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_block_stats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::block_stats", "dom, path");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
#line 1379 "Virt.xs"
      virDomainBlockStatsStruct stats;
#line 2967 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::block_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1381 "Virt.xs"
      if (virDomainBlockStats(dom, path, &stats, sizeof(stats)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "rd_req", 6, virt_newSVll(stats.rd_req), 0);
      (void)hv_store (RETVAL, "rd_bytes", 8, virt_newSVll(stats.rd_bytes), 0);
      (void)hv_store (RETVAL, "wr_req", 6, virt_newSVll(stats.wr_req), 0);
      (void)hv_store (RETVAL, "wr_bytes", 8, virt_newSVll(stats.wr_bytes), 0);
      (void)hv_store (RETVAL, "errs", 4, virt_newSVll(stats.errs), 0);
#line 2986 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_interface_stats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_interface_stats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::interface_stats", "dom, path");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
#line 1399 "Virt.xs"
      virDomainInterfaceStatsStruct stats;
#line 3010 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::interface_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1401 "Virt.xs"
      if (virDomainInterfaceStats(dom, path, &stats, sizeof(stats)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "rx_bytes", 8, virt_newSVll(stats.rx_bytes), 0);
      (void)hv_store (RETVAL, "rx_packets", 10, virt_newSVll(stats.rx_packets), 0);
      (void)hv_store (RETVAL, "rx_errs", 7, virt_newSVll(stats.rx_errs), 0);
      (void)hv_store (RETVAL, "rx_drop", 7, virt_newSVll(stats.rx_drop), 0);
      (void)hv_store (RETVAL, "tx_bytes", 8, virt_newSVll(stats.tx_bytes), 0);
      (void)hv_store (RETVAL, "tx_packets", 10, virt_newSVll(stats.tx_packets), 0);
      (void)hv_store (RETVAL, "tx_errs", 7, virt_newSVll(stats.tx_errs), 0);
      (void)hv_store (RETVAL, "tx_drop", 7, virt_newSVll(stats.tx_drop), 0);
#line 3032 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_block_peek); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_block_peek)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::block_peek", "dom, path, offset, size, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	unsigned int	offset = (unsigned int)SvUV(ST(2));
	size_t	size = (size_t)SvUV(ST(3));
	unsigned int	flags = (unsigned int)SvUV(ST(4));
#line 1425 "Virt.xs"
      char *buf;
#line 3059 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::block_peek() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1427 "Virt.xs"
      Newx(buf, size, char);
      if (virDomainBlockPeek(dom, path, offset, size, buf, flags) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpvn(buf, size);
#line 3074 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_memory_peek); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_memory_peek)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::memory_peek", "dom, offset, size, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	unsigned int	offset = (unsigned int)SvUV(ST(1));
	size_t	size = (size_t)SvUV(ST(2));
	unsigned int	flags = (unsigned int)SvUV(ST(3));
#line 1444 "Virt.xs"
      char *buf;
#line 3100 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::memory_peek() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1446 "Virt.xs"
      Newx(buf, size, char);
      if (virDomainMemoryPeek(dom, offset, size, buf, flags) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpvn(buf, size);
#line 3115 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_security_label); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_security_label)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_security_label", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 1460 "Virt.xs"
      virSecurityLabel seclabel;
#line 3138 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_security_label() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1462 "Virt.xs"
      if (virDomainGetSecurityLabel(dom, &seclabel) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "label", 5, newSVpv(seclabel.label, 0), 0);
      (void)hv_store (RETVAL, "enforcing", 9, newSViv(seclabel.enforcing), 0);
#line 3154 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_vcpu_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_vcpu_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_vcpu_info", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
#line 1476 "Virt.xs"
      virVcpuInfoPtr info;
      unsigned char *cpumaps;
      int maplen;
      virNodeInfo nodeinfo;
      virDomainInfo dominfo;
      int nvCpus;
      int i;
#line 3185 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_vcpu_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1484 "Virt.xs"
      if (virNodeGetInfo(virDomainGetConnect(dom), &nodeinfo) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      if (virDomainGetInfo(dom, &dominfo) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }

      Newx(info, dominfo.nrVirtCpu, virVcpuInfo);
      maplen = VIR_CPU_MAPLEN(VIR_NODEINFO_MAXCPUS(nodeinfo));
      Newx(cpumaps, dominfo.nrVirtCpu * maplen, unsigned char);
      if ((nvCpus = virDomainGetVcpus(dom, info, dominfo.nrVirtCpu, cpumaps, maplen)) < 0) {
	Safefree(info);
	Safefree(cpumaps);
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }

      EXTEND(SP, nvCpus);
      for (i = 0 ; i < nvCpus ; i++) {
	HV *rec = newHV();
	(void)hv_store(rec, "number", 6, newSViv(info[i].number), 0);
	(void)hv_store(rec, "state", 5, newSViv(info[i].state), 0);
	(void)hv_store(rec, "cpuTime", 7, virt_newSVull(info[i].cpuTime), 0);
	(void)hv_store(rec, "cpu", 3, newSViv(info[i].cpu), 0);
	(void)hv_store(rec, "affinity", 8, newSVpvn((char*)cpumaps + (i *maplen), maplen), 0);
	PUSHs(newRV_noinc((SV *)rec));
      }

      Safefree(info);
      Safefree(cpumaps);
#line 3223 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_pin_vcpu); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_pin_vcpu)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::pin_vcpu", "dom, vcpu, mask");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	vcpu = (unsigned int)SvUV(ST(1));
	SV *	mask = ST(2);
#line 1521 "Virt.xs"
     STRLEN masklen;
     unsigned char *maps;
#line 3250 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::pin_vcpu() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1524 "Virt.xs"
     maps = (unsigned char *)SvPV(mask, masklen);
     if (virDomainPinVcpu(dom, vcpu, maps, masklen) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
     }
#line 3263 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::destroy", "dom_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0);
#line 1534 "Virt.xs"
      virDomainPtr dom;
#line 3287 "Virt.c"
#line 1536 "Virt.xs"
      dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
      if (virDomainDestroy(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 3293 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::DESTROY", "dom_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0);
#line 1545 "Virt.xs"
      virDomainPtr dom;
#line 3317 "Virt.c"
#line 1547 "Virt.xs"
      dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
      if (dom) {
	virDomainFree(dom);
      }
#line 3323 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::_create_xml", "con, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1561 "Virt.xs"
      if (!(RETVAL = virNetworkCreateXML(con, xml))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3356 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::_define_xml", "con, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1572 "Virt.xs"
      if (!(RETVAL = virNetworkDefineXML(con, xml))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3392 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::_lookup_by_name", "con, name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1583 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByName(con, name))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3428 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::_lookup_by_uuid", "con, uuid");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1594 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByUUID(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3464 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::_lookup_by_uuid_string", "con, uuid");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1605 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByUUIDString(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3500 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::get_uuid", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNetworkPtr	net;
#line 1615 "Virt.xs"
      unsigned char rawuuid[16];
#line 3525 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_uuid() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1617 "Virt.xs"
      if ((virNetworkGetUUID(net, rawuuid)) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      RETVAL = newSVpv((char*)rawuuid, 16);
#line 3539 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::get_uuid_string", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNetworkPtr	net;
#line 1628 "Virt.xs"
      char uuid[36];
#line 3562 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_uuid_string() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1630 "Virt.xs"
      if ((virNetworkGetUUIDString(net, uuid)) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }

      RETVAL = newSVpv(uuid, 0);
#line 3577 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::get_name", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNetworkPtr	net;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1642 "Virt.xs"
      if (!(RETVAL = virNetworkGetName(net))) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 3611 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_bridge_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_bridge_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::get_bridge_name", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNetworkPtr	net;
#line 1653 "Virt.xs"
      char *name;
#line 3633 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_bridge_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1655 "Virt.xs"
      if (!(name = virNetworkGetBridgeName(net))) {
	 _croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      RETVAL = newSVpv(name, 0);
      free(name);
#line 3648 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::get_xml_description", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNetworkPtr	net;
#line 1667 "Virt.xs"
      char *xml;
#line 3671 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_xml_description() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1669 "Virt.xs"
      if (!(xml = virNetworkGetXMLDesc(net, 0))) {
	 _croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 3686 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::undefine", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::undefine() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1681 "Virt.xs"
      if (virNetworkUndefine(net) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 3720 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::create", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::create() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1689 "Virt.xs"
      if (virNetworkCreate(net) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 3753 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_set_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::set_autostart", "net, autostart");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;
	int	autostart = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::set_autostart() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1698 "Virt.xs"
      if (virNetworkSetAutostart(net, autostart) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 3787 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::get_autostart", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNetworkPtr	net;
#line 1707 "Virt.xs"
      int autostart;
#line 3809 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_autostart() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1709 "Virt.xs"
      if (virNetworkGetAutostart(net, &autostart) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      RETVAL = autostart;
#line 3824 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::destroy", "net_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0);
#line 1720 "Virt.xs"
      virNetworkPtr net;
#line 3848 "Virt.c"
#line 1722 "Virt.xs"
      net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
      if (virNetworkDestroy(net) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 3854 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::DESTROY", "net_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0);
#line 1731 "Virt.xs"
      virNetworkPtr net;
#line 3878 "Virt.c"
#line 1733 "Virt.xs"
      net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
      if (net) {
	virNetworkFree(net);
      }
#line 3884 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::_create_xml", "con, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1747 "Virt.xs"
      if (!(RETVAL = virStoragePoolCreateXML(con, xml, 0))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3917 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::_define_xml", "con, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1758 "Virt.xs"
      if (!(RETVAL = virStoragePoolDefineXML(con, xml, 0))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3952 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::_lookup_by_name", "con, name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1769 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByName(con, name))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3987 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::_lookup_by_uuid", "con, uuid");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1780 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByUUID(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 4022 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::_lookup_by_uuid_string", "con, uuid");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1791 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByUUIDString(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 4057 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_volume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_volume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::_lookup_by_volume", "vol");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStorageVolPtr	vol;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_volume() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1802 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByVolume(vol))) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
#line 4091 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::get_uuid", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStoragePoolPtr	pool;
#line 1813 "Virt.xs"
      unsigned char rawuuid[16];
#line 4115 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_uuid() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1815 "Virt.xs"
      if ((virStoragePoolGetUUID(pool, rawuuid)) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
      RETVAL = newSVpv((char*)rawuuid, 16);
#line 4129 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::get_uuid_string", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStoragePoolPtr	pool;
#line 1826 "Virt.xs"
      char uuid[36];
#line 4152 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_uuid_string() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1828 "Virt.xs"
      if ((virStoragePoolGetUUIDString(pool, uuid)) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }

      RETVAL = newSVpv(uuid, 0);
#line 4167 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::get_name", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStoragePoolPtr	pool;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_name() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1840 "Virt.xs"
      if (!(RETVAL = virStoragePoolGetName(pool))) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4201 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::get_xml_description", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStoragePoolPtr	pool;
#line 1851 "Virt.xs"
      char *xml;
#line 4223 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_xml_description() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1853 "Virt.xs"
      if (!(xml = virStoragePoolGetXMLDesc(pool, 0))) {
	 _croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 4238 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::undefine", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::undefine() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1865 "Virt.xs"
      if (virStoragePoolUndefine(pool) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4272 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::create", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::create() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1873 "Virt.xs"
      if (virStoragePoolCreate(pool, 0) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4305 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_refresh); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_refresh)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::refresh", "pool, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::refresh() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1882 "Virt.xs"
      if (virStoragePoolRefresh(pool, flags) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4339 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_build); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_build)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::build", "pool, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::build() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1891 "Virt.xs"
      if (virStoragePoolBuild(pool, flags) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4373 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::delete", "pool, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::delete() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1900 "Virt.xs"
      if (virStoragePoolDelete(pool, flags) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4407 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_set_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::set_autostart", "pool, autostart");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	autostart = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::set_autostart() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1909 "Virt.xs"
      if (virStoragePoolSetAutostart(pool, autostart) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4441 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::get_autostart", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStoragePoolPtr	pool;
#line 1918 "Virt.xs"
      int autostart;
#line 4463 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_autostart() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1920 "Virt.xs"
      if (virStoragePoolGetAutostart(pool, &autostart) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
      RETVAL = autostart;
#line 4478 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::get_info", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStoragePoolPtr	pool;
#line 1932 "Virt.xs"
      virStoragePoolInfo info;
#line 4500 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_info() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1934 "Virt.xs"
      if (virStoragePoolGetInfo(pool, &info) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
      (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
      (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
      (void)hv_store (RETVAL, "available", 9, virt_newSVull(info.available), 0);
#line 4518 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::destroy", "pool_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	pool_rv = ST(0);
#line 1949 "Virt.xs"
      virStoragePoolPtr pool;
#line 4543 "Virt.c"
#line 1951 "Virt.xs"
      pool = (virStoragePoolPtr)SvIV((SV*)SvRV(pool_rv));
      if (virStoragePoolDestroy(pool) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4549 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_num_of_storage_volumes); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_num_of_storage_volumes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::num_of_storage_volumes", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStoragePoolPtr	pool;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::num_of_storage_volumes() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1960 "Virt.xs"
      if ((RETVAL = virStoragePoolNumOfVolumes(pool)) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4582 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_list_storage_vol_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_list_storage_vol_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::list_storage_vol_names", "pool, maxnames");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	maxnames = (int)SvIV(ST(1));
#line 1971 "Virt.xs"
      char **names;
      int i, nnet;
#line 4608 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::list_storage_vol_names() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1974 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virStoragePoolListVolumes(pool, names, maxnames)) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 4627 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StoragePool::DESTROY", "pool_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	pool_rv = ST(0);
#line 1991 "Virt.xs"
      virStoragePoolPtr pool;
#line 4651 "Virt.c"
#line 1993 "Virt.xs"
      pool = (virStoragePoolPtr)SvIV((SV*)SvRV(pool_rv));
      if (pool) {
	virStoragePoolFree(pool);
      }
#line 4657 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StorageVol__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StorageVol::_create_xml", "pool, xml, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStoragePoolPtr	pool;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	int	flags = (int)SvIV(ST(2));
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2007 "Virt.xs"
      if (!(RETVAL = virStorageVolCreateXML(pool, xml, flags))) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4691 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StorageVol::_lookup_by_name", "pool, name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStoragePoolPtr	pool;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_name() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2018 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByName(pool, name))) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4726 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol__lookup_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__lookup_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StorageVol::_lookup_by_key", "con, key");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	key = (const char *)SvPV_nolen(ST(1));
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_key() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2029 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByKey(con, key))) {
	_croak_error(virConnGetLastError(con));
      }
#line 4761 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol__lookup_by_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__lookup_by_path)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StorageVol::_lookup_by_path", "con, path");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_path() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2040 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByPath(con, path))) {
	_croak_error(virConnGetLastError(con));
      }
#line 4796 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StorageVol::get_name", "vol");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_name() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2050 "Virt.xs"
      if (!(RETVAL = virStorageVolGetName(vol))) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
#line 4831 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_get_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StorageVol::get_key", "vol");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_key() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2061 "Virt.xs"
      if (!(RETVAL = virStorageVolGetKey(vol))) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
#line 4864 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_get_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_path)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StorageVol::get_path", "vol");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_path() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2072 "Virt.xs"
      if (!(RETVAL = virStorageVolGetPath(vol))) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
#line 4897 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StorageVol::get_xml_description", "vol");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStorageVolPtr	vol;
#line 2083 "Virt.xs"
      char *xml;
#line 4919 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_xml_description() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2085 "Virt.xs"
      if (!(xml = virStorageVolGetXMLDesc(vol, 0))) {
	 _croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 4934 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StorageVol::delete", "vol, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	int	flags = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::delete() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2098 "Virt.xs"
      if (virStorageVolDelete(vol, flags) < 0) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
#line 4969 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StorageVol_get_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StorageVol::get_info", "vol");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virStorageVolPtr	vol;
#line 2107 "Virt.xs"
      virStorageVolInfo info;
#line 4991 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_info() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2109 "Virt.xs"
      if (virStorageVolGetInfo(vol, &info) < 0) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "type", 4, newSViv(info.type), 0);
      (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
      (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
#line 5008 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::StorageVol::DESTROY", "vol_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	vol_rv = ST(0);
#line 2123 "Virt.xs"
      virStorageVolPtr vol;
#line 5033 "Virt.c"
#line 2125 "Virt.xs"
      vol = (virStorageVolPtr)SvIV((SV*)SvRV(vol_rv));
      if (vol) {
	virStorageVolFree(vol);
      }
#line 5039 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::NodeDevice::_lookup_by_name", "con, name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2139 "Virt.xs"
      if (!(RETVAL = virNodeDeviceLookupByName(con, name))) {
	_croak_error(virConnGetLastError(con));
      }
#line 5072 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NodeDevice", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::NodeDevice::get_name", "dev");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNodeDevicePtr	dev;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::get_name() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2149 "Virt.xs"
      if (!(RETVAL = virNodeDeviceGetName(dev))) {
	_croak_error(virGetLastError());
      }
#line 5107 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_get_parent); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_get_parent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::NodeDevice::get_parent", "dev");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNodeDevicePtr	dev;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::get_parent() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2160 "Virt.xs"
      if (!(RETVAL = virNodeDeviceGetParent(dev))) {
	_croak_error(virGetLastError());
      }
#line 5140 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::NodeDevice::get_xml_description", "dev");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNodeDevicePtr	dev;
#line 2171 "Virt.xs"
      char *xml;
#line 5162 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::get_xml_description() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2173 "Virt.xs"
      if (!(xml = virNodeDeviceGetXMLDesc(dev, 0))) {
	_croak_error(virGetLastError());
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 5177 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_dettach); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_dettach)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::NodeDevice::dettach", "dev");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::dettach() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2185 "Virt.xs"
      if (virNodeDeviceDettach(dev) < 0) {
	_croak_error(virGetLastError());
      }
#line 5211 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_reattach); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_reattach)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::NodeDevice::reattach", "dev");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::reattach() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2193 "Virt.xs"
      if (virNodeDeviceReAttach(dev) < 0) {
	_croak_error(virGetLastError());
      }
#line 5244 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_reset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_reset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::NodeDevice::reset", "dev");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::reset() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2201 "Virt.xs"
      if (virNodeDeviceReset(dev) < 0) {
	_croak_error(virGetLastError());
      }
#line 5277 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_list_capabilities); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_list_capabilities)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::NodeDevice::list_capabilities", "dev");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;
#line 2209 "Virt.xs"
      int maxnames;
      char **names;
      int i, nnet;
#line 5303 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::list_capabilities() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2213 "Virt.xs"
      if ((maxnames = virNodeDeviceNumOfCaps(dev)) < 0) {
	_croak_error(virGetLastError());
      }
      Newx(names, maxnames, char *);
      if ((nnet = virNodeDeviceListCaps(dev, names, maxnames)) < 0) {
	_croak_error(virGetLastError());
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 5325 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::NodeDevice::DESTROY", "dev_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dev_rv = ST(0);
#line 2232 "Virt.xs"
      virNodeDevicePtr dev;
#line 5349 "Virt.c"
#line 2234 "Virt.xs"
      dev = (virNodeDevicePtr)SvIV((SV*)SvRV(dev_rv));
      if (dev) {
	virNodeDeviceFree(dev);
      }
#line 5355 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__register_impl); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__register_impl)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Event::_register_impl", "");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2246 "Virt.xs"
      virEventRegisterImpl(_event_add_handle,
			   _event_update_handle,
			   _event_remove_handle,
			   _event_add_timeout,
			   _event_update_timeout,
			   _event_remove_timeout);
#line 5383 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__run_handle_callback_helper); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__run_handle_callback_helper)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Event::_run_handle_callback_helper", "watch, fd, event, cbref, opaqueref");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	watch = (int)SvIV(ST(0));
	int	fd = (int)SvIV(ST(1));
	int	event = (int)SvIV(ST(2));
	SV *	cbref = ST(3);
	SV *	opaqueref = ST(4);
#line 2261 "Virt.xs"
      virEventHandleCallback cb;
      void *opaque;
#line 5412 "Virt.c"
#line 2264 "Virt.xs"
      cb = (virEventHandleCallback)SvIV((SV*)SvRV(cbref));
      opaque = (void*)SvIV((SV*)SvRV(opaqueref));

      cb(watch, fd, event, opaque);
#line 5418 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__run_timeout_callback_helper); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__run_timeout_callback_helper)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Event::_run_timeout_callback_helper", "timer, cbref, opaqueref");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	timer = (int)SvIV(ST(0));
	SV *	cbref = ST(1);
	SV *	opaqueref = ST(2);
#line 2276 "Virt.xs"
      virEventTimeoutCallback cb;
      void *opaque;
#line 5445 "Virt.c"
#line 2279 "Virt.xs"
      cb = (virEventTimeoutCallback)SvIV((SV*)SvRV(cbref));
      opaque = (void*)SvIV((SV*)SvRV(opaqueref));

      cb(timer, opaque);
#line 5451 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__free_callback_opaque_helper); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__free_callback_opaque_helper)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Event::_free_callback_opaque_helper", "ffref, opaqueref");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ffref = ST(0);
	SV *	opaqueref = ST(1);
#line 2290 "Virt.xs"
      virFreeCallback ff;
      void *opaque;
#line 5477 "Virt.c"
#line 2293 "Virt.xs"
      opaque = SvOK(opaqueref) ? (void*)SvIV((SV*)SvRV(opaqueref)) : NULL;
      ff = SvOK(ffref) ? (virFreeCallback)SvIV((SV*)SvRV(ffref)) : NULL;

      if (opaque != NULL && ff != NULL)
        ff(opaque);
#line 5484 "Virt.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Sys__Virt); /* prototype to pass -Wmissing-prototypes */
XS(boot_Sys__Virt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Sys::Virt::_open", XS_Sys__Virt__open, file, "$$");
        newXSproto("Sys::Virt::_open_auth", XS_Sys__Virt__open_auth, file, "$$$$");
        newXSproto("Sys::Virt::restore_domain", XS_Sys__Virt_restore_domain, file, "$$");
        newXSproto("Sys::Virt::_get_library_version", XS_Sys__Virt__get_library_version, file, "$");
        newXSproto("Sys::Virt::_get_conn_version", XS_Sys__Virt__get_conn_version, file, "$");
        newXSproto("Sys::Virt::get_type", XS_Sys__Virt_get_type, file, "$");
        newXSproto("Sys::Virt::get_uri", XS_Sys__Virt_get_uri, file, "$");
        newXSproto("Sys::Virt::get_node_info", XS_Sys__Virt_get_node_info, file, "$");
        newXSproto("Sys::Virt::get_node_security_model", XS_Sys__Virt_get_node_security_model, file, "$");
        newXSproto("Sys::Virt::get_node_free_memory", XS_Sys__Virt_get_node_free_memory, file, "$");
        newXSproto("Sys::Virt::get_node_cells_free_memory", XS_Sys__Virt_get_node_cells_free_memory, file, "$$$");
        newXSproto("Sys::Virt::find_storage_pool_sources", XS_Sys__Virt_find_storage_pool_sources, file, "$$$$");
        newXSproto("Sys::Virt::get_capabilities", XS_Sys__Virt_get_capabilities, file, "$");
        newXSproto("Sys::Virt::get_max_vcpus", XS_Sys__Virt_get_max_vcpus, file, "$$");
        newXSproto("Sys::Virt::get_hostname", XS_Sys__Virt_get_hostname, file, "$");
        newXSproto("Sys::Virt::num_of_domains", XS_Sys__Virt_num_of_domains, file, "$");
        newXSproto("Sys::Virt::list_domain_ids", XS_Sys__Virt_list_domain_ids, file, "$$");
        newXSproto("Sys::Virt::num_of_defined_domains", XS_Sys__Virt_num_of_defined_domains, file, "$");
        newXSproto("Sys::Virt::list_defined_domain_names", XS_Sys__Virt_list_defined_domain_names, file, "$$");
        newXSproto("Sys::Virt::num_of_networks", XS_Sys__Virt_num_of_networks, file, "$");
        newXSproto("Sys::Virt::list_network_names", XS_Sys__Virt_list_network_names, file, "$$");
        newXSproto("Sys::Virt::num_of_defined_networks", XS_Sys__Virt_num_of_defined_networks, file, "$");
        newXSproto("Sys::Virt::list_defined_network_names", XS_Sys__Virt_list_defined_network_names, file, "$$");
        newXSproto("Sys::Virt::num_of_storage_pools", XS_Sys__Virt_num_of_storage_pools, file, "$");
        newXSproto("Sys::Virt::list_storage_pool_names", XS_Sys__Virt_list_storage_pool_names, file, "$$");
        newXSproto("Sys::Virt::num_of_defined_storage_pools", XS_Sys__Virt_num_of_defined_storage_pools, file, "$");
        newXSproto("Sys::Virt::list_defined_storage_pool_names", XS_Sys__Virt_list_defined_storage_pool_names, file, "$$");
        newXSproto("Sys::Virt::num_of_node_devices", XS_Sys__Virt_num_of_node_devices, file, "$$$");
        newXSproto("Sys::Virt::list_node_device_names", XS_Sys__Virt_list_node_device_names, file, "$$$$");
        newXSproto("Sys::Virt::domain_event_register", XS_Sys__Virt_domain_event_register, file, "$$");
        newXSproto("Sys::Virt::domain_event_deregister", XS_Sys__Virt_domain_event_deregister, file, "$");
        newXSproto("Sys::Virt::DESTROY", XS_Sys__Virt_DESTROY, file, "$");
        newXSproto("Sys::Virt::Domain::_create_linux", XS_Sys__Virt__Domain__create_linux, file, "$$");
        newXSproto("Sys::Virt::Domain::_define_xml", XS_Sys__Virt__Domain__define_xml, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_id", XS_Sys__Virt__Domain__lookup_by_id, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_name", XS_Sys__Virt__Domain__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_uuid", XS_Sys__Virt__Domain__lookup_by_uuid, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_uuid_string", XS_Sys__Virt__Domain__lookup_by_uuid_string, file, "$$");
        newXSproto("Sys::Virt::Domain::get_id", XS_Sys__Virt__Domain_get_id, file, "$");
        newXSproto("Sys::Virt::Domain::get_uuid", XS_Sys__Virt__Domain_get_uuid, file, "$");
        newXSproto("Sys::Virt::Domain::get_uuid_string", XS_Sys__Virt__Domain_get_uuid_string, file, "$");
        newXSproto("Sys::Virt::Domain::get_name", XS_Sys__Virt__Domain_get_name, file, "$");
        newXSproto("Sys::Virt::Domain::suspend", XS_Sys__Virt__Domain_suspend, file, "$");
        newXSproto("Sys::Virt::Domain::resume", XS_Sys__Virt__Domain_resume, file, "$");
        newXSproto("Sys::Virt::Domain::save", XS_Sys__Virt__Domain_save, file, "$$");
        newXSproto("Sys::Virt::Domain::core_dump", XS_Sys__Virt__Domain_core_dump, file, "$$$");
        newXSproto("Sys::Virt::Domain::get_info", XS_Sys__Virt__Domain_get_info, file, "$");
        newXSproto("Sys::Virt::Domain::get_scheduler_parameters", XS_Sys__Virt__Domain_get_scheduler_parameters, file, "$");
        newXSproto("Sys::Virt::Domain::set_scheduler_parameters", XS_Sys__Virt__Domain_set_scheduler_parameters, file, "$$");
        newXSproto("Sys::Virt::Domain::get_max_memory", XS_Sys__Virt__Domain_get_max_memory, file, "$");
        newXSproto("Sys::Virt::Domain::set_max_memory", XS_Sys__Virt__Domain_set_max_memory, file, "$$");
        newXSproto("Sys::Virt::Domain::set_memory", XS_Sys__Virt__Domain_set_memory, file, "$$");
        newXSproto("Sys::Virt::Domain::get_max_vcpus", XS_Sys__Virt__Domain_get_max_vcpus, file, "$");
        newXSproto("Sys::Virt::Domain::set_vcpus", XS_Sys__Virt__Domain_set_vcpus, file, "$$");
        newXSproto("Sys::Virt::Domain::set_autostart", XS_Sys__Virt__Domain_set_autostart, file, "$$");
        newXSproto("Sys::Virt::Domain::get_autostart", XS_Sys__Virt__Domain_get_autostart, file, "$");
        newXSproto("Sys::Virt::Domain::get_scheduler_type", XS_Sys__Virt__Domain_get_scheduler_type, file, "$");
        newXSproto("Sys::Virt::Domain::get_os_type", XS_Sys__Virt__Domain_get_os_type, file, "$");
        newXSproto("Sys::Virt::Domain::get_xml_description", XS_Sys__Virt__Domain_get_xml_description, file, "$");
        newXSproto("Sys::Virt::Domain::shutdown", XS_Sys__Virt__Domain_shutdown, file, "$");
        newXSproto("Sys::Virt::Domain::reboot", XS_Sys__Virt__Domain_reboot, file, "$$");
        newXSproto("Sys::Virt::Domain::undefine", XS_Sys__Virt__Domain_undefine, file, "$");
        newXSproto("Sys::Virt::Domain::create", XS_Sys__Virt__Domain_create, file, "$");
        newXSproto("Sys::Virt::Domain::migrate", XS_Sys__Virt__Domain_migrate, file, "$$$$$$");
        newXSproto("Sys::Virt::Domain::attach_device", XS_Sys__Virt__Domain_attach_device, file, "$$");
        newXSproto("Sys::Virt::Domain::detach_device", XS_Sys__Virt__Domain_detach_device, file, "$$");
        newXSproto("Sys::Virt::Domain::block_stats", XS_Sys__Virt__Domain_block_stats, file, "$$");
        newXSproto("Sys::Virt::Domain::interface_stats", XS_Sys__Virt__Domain_interface_stats, file, "$$");
        newXSproto("Sys::Virt::Domain::block_peek", XS_Sys__Virt__Domain_block_peek, file, "$$$$$");
        newXSproto("Sys::Virt::Domain::memory_peek", XS_Sys__Virt__Domain_memory_peek, file, "$$$$");
        newXSproto("Sys::Virt::Domain::get_security_label", XS_Sys__Virt__Domain_get_security_label, file, "$");
        newXSproto("Sys::Virt::Domain::get_vcpu_info", XS_Sys__Virt__Domain_get_vcpu_info, file, "$");
        newXSproto("Sys::Virt::Domain::pin_vcpu", XS_Sys__Virt__Domain_pin_vcpu, file, "$$$");
        newXSproto("Sys::Virt::Domain::destroy", XS_Sys__Virt__Domain_destroy, file, "$");
        newXSproto("Sys::Virt::Domain::DESTROY", XS_Sys__Virt__Domain_DESTROY, file, "$");
        newXSproto("Sys::Virt::Network::_create_xml", XS_Sys__Virt__Network__create_xml, file, "$$");
        newXSproto("Sys::Virt::Network::_define_xml", XS_Sys__Virt__Network__define_xml, file, "$$");
        newXSproto("Sys::Virt::Network::_lookup_by_name", XS_Sys__Virt__Network__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::Network::_lookup_by_uuid", XS_Sys__Virt__Network__lookup_by_uuid, file, "$$");
        newXSproto("Sys::Virt::Network::_lookup_by_uuid_string", XS_Sys__Virt__Network__lookup_by_uuid_string, file, "$$");
        newXSproto("Sys::Virt::Network::get_uuid", XS_Sys__Virt__Network_get_uuid, file, "$");
        newXSproto("Sys::Virt::Network::get_uuid_string", XS_Sys__Virt__Network_get_uuid_string, file, "$");
        newXSproto("Sys::Virt::Network::get_name", XS_Sys__Virt__Network_get_name, file, "$");
        newXSproto("Sys::Virt::Network::get_bridge_name", XS_Sys__Virt__Network_get_bridge_name, file, "$");
        newXSproto("Sys::Virt::Network::get_xml_description", XS_Sys__Virt__Network_get_xml_description, file, "$");
        newXSproto("Sys::Virt::Network::undefine", XS_Sys__Virt__Network_undefine, file, "$");
        newXSproto("Sys::Virt::Network::create", XS_Sys__Virt__Network_create, file, "$");
        newXSproto("Sys::Virt::Network::set_autostart", XS_Sys__Virt__Network_set_autostart, file, "$$");
        newXSproto("Sys::Virt::Network::get_autostart", XS_Sys__Virt__Network_get_autostart, file, "$");
        newXSproto("Sys::Virt::Network::destroy", XS_Sys__Virt__Network_destroy, file, "$");
        newXSproto("Sys::Virt::Network::DESTROY", XS_Sys__Virt__Network_DESTROY, file, "$");
        newXSproto("Sys::Virt::StoragePool::_create_xml", XS_Sys__Virt__StoragePool__create_xml, file, "$$");
        newXSproto("Sys::Virt::StoragePool::_define_xml", XS_Sys__Virt__StoragePool__define_xml, file, "$$");
        newXSproto("Sys::Virt::StoragePool::_lookup_by_name", XS_Sys__Virt__StoragePool__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::StoragePool::_lookup_by_uuid", XS_Sys__Virt__StoragePool__lookup_by_uuid, file, "$$");
        newXSproto("Sys::Virt::StoragePool::_lookup_by_uuid_string", XS_Sys__Virt__StoragePool__lookup_by_uuid_string, file, "$$");
        newXSproto("Sys::Virt::StoragePool::_lookup_by_volume", XS_Sys__Virt__StoragePool__lookup_by_volume, file, "$");
        newXSproto("Sys::Virt::StoragePool::get_uuid", XS_Sys__Virt__StoragePool_get_uuid, file, "$");
        newXSproto("Sys::Virt::StoragePool::get_uuid_string", XS_Sys__Virt__StoragePool_get_uuid_string, file, "$");
        newXSproto("Sys::Virt::StoragePool::get_name", XS_Sys__Virt__StoragePool_get_name, file, "$");
        newXSproto("Sys::Virt::StoragePool::get_xml_description", XS_Sys__Virt__StoragePool_get_xml_description, file, "$");
        newXSproto("Sys::Virt::StoragePool::undefine", XS_Sys__Virt__StoragePool_undefine, file, "$");
        newXSproto("Sys::Virt::StoragePool::create", XS_Sys__Virt__StoragePool_create, file, "$");
        newXSproto("Sys::Virt::StoragePool::refresh", XS_Sys__Virt__StoragePool_refresh, file, "$$");
        newXSproto("Sys::Virt::StoragePool::build", XS_Sys__Virt__StoragePool_build, file, "$$");
        newXSproto("Sys::Virt::StoragePool::delete", XS_Sys__Virt__StoragePool_delete, file, "$$");
        newXSproto("Sys::Virt::StoragePool::set_autostart", XS_Sys__Virt__StoragePool_set_autostart, file, "$$");
        newXSproto("Sys::Virt::StoragePool::get_autostart", XS_Sys__Virt__StoragePool_get_autostart, file, "$");
        newXSproto("Sys::Virt::StoragePool::get_info", XS_Sys__Virt__StoragePool_get_info, file, "$");
        newXSproto("Sys::Virt::StoragePool::destroy", XS_Sys__Virt__StoragePool_destroy, file, "$");
        newXSproto("Sys::Virt::StoragePool::num_of_storage_volumes", XS_Sys__Virt__StoragePool_num_of_storage_volumes, file, "$");
        newXSproto("Sys::Virt::StoragePool::list_storage_vol_names", XS_Sys__Virt__StoragePool_list_storage_vol_names, file, "$$");
        newXSproto("Sys::Virt::StoragePool::DESTROY", XS_Sys__Virt__StoragePool_DESTROY, file, "$");
        newXSproto("Sys::Virt::StorageVol::_create_xml", XS_Sys__Virt__StorageVol__create_xml, file, "$$$");
        newXSproto("Sys::Virt::StorageVol::_lookup_by_name", XS_Sys__Virt__StorageVol__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::StorageVol::_lookup_by_key", XS_Sys__Virt__StorageVol__lookup_by_key, file, "$$");
        newXSproto("Sys::Virt::StorageVol::_lookup_by_path", XS_Sys__Virt__StorageVol__lookup_by_path, file, "$$");
        newXSproto("Sys::Virt::StorageVol::get_name", XS_Sys__Virt__StorageVol_get_name, file, "$");
        newXSproto("Sys::Virt::StorageVol::get_key", XS_Sys__Virt__StorageVol_get_key, file, "$");
        newXSproto("Sys::Virt::StorageVol::get_path", XS_Sys__Virt__StorageVol_get_path, file, "$");
        newXSproto("Sys::Virt::StorageVol::get_xml_description", XS_Sys__Virt__StorageVol_get_xml_description, file, "$");
        newXSproto("Sys::Virt::StorageVol::delete", XS_Sys__Virt__StorageVol_delete, file, "$$");
        newXSproto("Sys::Virt::StorageVol::get_info", XS_Sys__Virt__StorageVol_get_info, file, "$");
        newXSproto("Sys::Virt::StorageVol::DESTROY", XS_Sys__Virt__StorageVol_DESTROY, file, "$");
        newXSproto("Sys::Virt::NodeDevice::_lookup_by_name", XS_Sys__Virt__NodeDevice__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::NodeDevice::get_name", XS_Sys__Virt__NodeDevice_get_name, file, "$");
        newXSproto("Sys::Virt::NodeDevice::get_parent", XS_Sys__Virt__NodeDevice_get_parent, file, "$");
        newXSproto("Sys::Virt::NodeDevice::get_xml_description", XS_Sys__Virt__NodeDevice_get_xml_description, file, "$");
        newXSproto("Sys::Virt::NodeDevice::dettach", XS_Sys__Virt__NodeDevice_dettach, file, "$");
        newXSproto("Sys::Virt::NodeDevice::reattach", XS_Sys__Virt__NodeDevice_reattach, file, "$");
        newXSproto("Sys::Virt::NodeDevice::reset", XS_Sys__Virt__NodeDevice_reset, file, "$");
        newXSproto("Sys::Virt::NodeDevice::list_capabilities", XS_Sys__Virt__NodeDevice_list_capabilities, file, "$");
        newXSproto("Sys::Virt::NodeDevice::DESTROY", XS_Sys__Virt__NodeDevice_DESTROY, file, "$");
        newXSproto("Sys::Virt::Event::_register_impl", XS_Sys__Virt__Event__register_impl, file, "");
        newXSproto("Sys::Virt::Event::_run_handle_callback_helper", XS_Sys__Virt__Event__run_handle_callback_helper, file, "$$$$$");
        newXSproto("Sys::Virt::Event::_run_timeout_callback_helper", XS_Sys__Virt__Event__run_timeout_callback_helper, file, "$$$");
        newXSproto("Sys::Virt::Event::_free_callback_opaque_helper", XS_Sys__Virt__Event__free_callback_opaque_helper, file, "$$");

    /* Initialisation Section */

#line 2308 "Virt.xs"
    {
      HV *stash;

      virSetErrorFunc(NULL, ignoreVirErrorFunc);

      stash = gv_stashpv( "Sys::Virt", TRUE );

      /*
       * Not required
      RGISTER_CONSTANT(VIR_CONNECT_RO, CONNECT_RO);
      */

      REGISTER_CONSTANT(VIR_CRED_USERNAME, CRED_USERNAME);
      REGISTER_CONSTANT(VIR_CRED_AUTHNAME, CRED_AUTHNAME);
      REGISTER_CONSTANT(VIR_CRED_LANGUAGE, CRED_LANGUAGE);
      REGISTER_CONSTANT(VIR_CRED_CNONCE, CRED_CNONCE);
      REGISTER_CONSTANT(VIR_CRED_PASSPHRASE, CRED_PASSPHRASE);
      REGISTER_CONSTANT(VIR_CRED_ECHOPROMPT, CRED_ECHOPROMPT);
      REGISTER_CONSTANT(VIR_CRED_NOECHOPROMPT, CRED_NOECHOPROMPT);
      REGISTER_CONSTANT(VIR_CRED_REALM, CRED_REALM);
      REGISTER_CONSTANT(VIR_CRED_EXTERNAL, CRED_EXTERNAL);


      stash = gv_stashpv( "Sys::Virt::Event", TRUE );

      REGISTER_CONSTANT(VIR_EVENT_HANDLE_READABLE, HANDLE_READABLE);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_WRITABLE, HANDLE_WRITABLE);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_ERROR, HANDLE_ERROR);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_HANGUP, HANDLE_HANGUP);


      stash = gv_stashpv( "Sys::Virt::Domain", TRUE );
      REGISTER_CONSTANT(VIR_DOMAIN_NOSTATE, STATE_NOSTATE);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING, STATE_RUNNING);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCKED, STATE_BLOCKED);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED, STATE_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN, STATE_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF, STATE_SHUTOFF);
      REGISTER_CONSTANT(VIR_DOMAIN_CRASHED, STATE_CRASHED);

      /*
       * This constant is not really useful yet
      REGISTER_CONSTANT(VIR_DOMAIN_NONE, CREATE_NONE);
      */

      /* NB: skip VIR_DOMAIN_SCHED_FIELD_* constants, because
         those are not used from Perl code - handled internally
         in the XS layer */

      REGISTER_CONSTANT(VIR_MIGRATE_LIVE, MIGRATE_LIVE);


      REGISTER_CONSTANT(VIR_DOMAIN_XML_SECURE, XML_SECURE);
      REGISTER_CONSTANT(VIR_DOMAIN_XML_INACTIVE, XML_INACTIVE);

      REGISTER_CONSTANT(VIR_MEMORY_VIRTUAL, MEMORY_VIRTUAL);

      REGISTER_CONSTANT(VIR_VCPU_OFFLINE, VCPU_OFFLINE);
      REGISTER_CONSTANT(VIR_VCPU_RUNNING, VCPU_RUNNING);
      REGISTER_CONSTANT(VIR_VCPU_BLOCKED, VCPU_BLOCKED);


      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED, EVENT_DEFINED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_UNDEFINED, EVENT_UNDEFINED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED, EVENT_STARTED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED, EVENT_SUSPENDED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED, EVENT_RESUMED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED, EVENT_STOPPED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_ADDED, EVENT_DEFINED_ADDED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_UPDATED, EVENT_DEFINED_UPDATED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_UNDEFINED_REMOVED, EVENT_UNDEFINED_REMOVED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_BOOTED, EVENT_STARTED_BOOTED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_MIGRATED, EVENT_STARTED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_RESTORED, EVENT_STARTED_RESTORED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_PAUSED, EVENT_SUSPENDED_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_MIGRATED, EVENT_SUSPENDED_MIGRATED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_UNPAUSED, EVENT_RESUMED_UNPAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_MIGRATED, EVENT_RESUMED_MIGRATED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_SHUTDOWN, EVENT_STOPPED_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_DESTROYED, EVENT_STOPPED_DESTROYED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_CRASHED, EVENT_STOPPED_CRASHED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_MIGRATED, EVENT_STOPPED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_SAVED, EVENT_STOPPED_SAVED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_FAILED, EVENT_STOPPED_FAILED);



      stash = gv_stashpv( "Sys::Virt::StoragePool", TRUE );
      REGISTER_CONSTANT(VIR_STORAGE_POOL_INACTIVE, STATE_INACTIVE);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILDING, STATE_BUILDING);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_RUNNING, STATE_RUNNING);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_DEGRADED, STATE_DEGRADED);

      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_NEW, BUILD_NEW);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_REPAIR, BUILD_REPAIR);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_RESIZE, BUILD_RESIZE);

      REGISTER_CONSTANT(VIR_STORAGE_POOL_DELETE_NORMAL, DELETE_NORMAL);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_DELETE_ZEROED, DELETE_ZEROED);


      stash = gv_stashpv( "Sys::Virt::StorageVol", TRUE );
      REGISTER_CONSTANT(VIR_STORAGE_VOL_FILE, TYPE_FILE);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_BLOCK, TYPE_BLOCK);

      REGISTER_CONSTANT(VIR_STORAGE_VOL_DELETE_NORMAL, DELETE_NORMAL);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_DELETE_ZEROED, DELETE_ZEROED);
    }

#line 5763 "Virt.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

